/**********************************************************************************************/
/*                                                                                            */
/*                            .                               */
/*                                                                                            */
/**********************************************************************************************/
#ifndef ASYNC_TIMER_H
#define ASYNC_TIMER_H

#include  "../main/main.h"


#ifndef TIMER_DEFINE
#define TIMER_DEFINE

/*--------------------------------------------------------------------------------------------*/
/*   ,   .                                               */
/*        .                                   */
/*--------------------------------------------------------------------------------------------*/
typedef   void (*pTIMER_FUNC)(void);

/*--------------------------------------------------------------------------------------------*/
/*   .                                                            */
/*--------------------------------------------------------------------------------------------*/
struct TIMER
{
  union                     //   .
    {
      BYTE Flags;
      struct
        {
          BYTE Timer_Ena    : 1,  // "1" -   ,
                                  // "0" -   / .
               Timer_Cycle  : 1;  // "1" -    ,
                                  // "0" -    .
        };
    };
  WORD          Interval;   //  .
  WORD          Counter;    //   .
  pTIMER_FUNC   pFunc;      //  .
};

/*--------------------------------------------------------------------------------------------*/
/*   /  .                                                        */
/*--------------------------------------------------------------------------------------------*/
#define   TIMER_ENA         true
#define   TIMER_DIS         false

/*--------------------------------------------------------------------------------------------*/
/*     / .                                 */
/*--------------------------------------------------------------------------------------------*/
#define   TIMER_CYCLE       true
#define   TIMER_ONCE        false

#endif


/*--------------------------------------------------------------------------------------------*/
/*    .                                                   */
/*--------------------------------------------------------------------------------------------*/
extern struct TIMER Async_Timer[8];

/*--------------------------------------------------------------------------------------------*/
/*    .                                              */
/* :     .                                                          */
/* :    .                                                         */
/*--------------------------------------------------------------------------------------------*/
void Async_Timer_Init(void);

/*--------------------------------------------------------------------------------------------*/
/*   .                                                                 */
/* :     (0 - 7),                                                        */
/*                   (1..65535),                                        */
/*                   ( NULL),                           */
/*                .                                                   */
/* :    .                                                         */
/*--------------------------------------------------------------------------------------------*/
void Start_Async_Timer(IN IDX timer, IN WORD interval, IN pTIMER_FUNC pFunc = NULL, IN bool cycle = TIMER_ONCE);

/*--------------------------------------------------------------------------------------------*/
/*   .                                                               */
/* :     (0 - 7).                                                        */
/* :    .                                                         */
/*--------------------------------------------------------------------------------------------*/
void Stop_Async_Timer(IN IDX timer);

/*--------------------------------------------------------------------------------------------*/
/*     .                                           */
/* :     (0 - 7).                                                        */
/* :  TRUE,   .                                                 */
/*--------------------------------------------------------------------------------------------*/
#define   is_Async_Timer_Stopped(timer)   (Async_Timer[(timer)].Timer_Ena != TIMER_ENA)


/**********************************************************************************************/
#endif
